var through     = require('through2');
var gutil       = require('gulp-util');
var _           = require('lodash');
var PluginError = gutil.PluginError;

var angularModulesFactory =
  new (require('angular-dependency/lib')).AngularModulesFactory();

// consts
const PLUGIN_NAME = 'gulp-angular-dependency';

// plugin level function (dealing with files)
function gulpAngularDependency (modules) {

  var files = {};
  modules = modules || [];
  if (typeof modules === 'string') { modules = [modules]; }

  // creating a stream through which each file will pass
  // returning the file stream
  return through.obj(function (file, enc, cb) {
    if (file.isNull()) {
      // do nothing if no contents
    }

    angularModulesFactory.processFile(file.contents.toString(), file.path);
    files[file.path] = file;

    return cb();
  }, function () {
    var topology = angularModulesFactory.getAngularModules();
    var that = this;

    _.each(modules, function (module) {
      _.each(topology.resolve(module, true), function (module) {
          that.emit('data', files[module.defined]);

          _.each(module.content, function (path) {
            that.emit('data', files[path]);
          });
        });
    });
    this.emit('end');
  });
}

// exporting the plugin main function
module.exports = gulpAngularDependency;